# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['ConfigArgs', 'Config']

@pulumi.input_type
class ConfigArgs:
    def __init__(__self__, *,
                 sync_interval: pulumi.Input[int],
                 sync_level: pulumi.Input[str]):
        """
        The set of arguments for constructing a Config resource.
        :param pulumi.Input[int] sync_interval: List Update Interval.
        :param pulumi.Input[str] sync_level: Clean library level.
        """
        pulumi.set(__self__, "sync_interval", sync_interval)
        pulumi.set(__self__, "sync_level", sync_level)

    @property
    @pulumi.getter(name="syncInterval")
    def sync_interval(self) -> pulumi.Input[int]:
        """
        List Update Interval.
        """
        return pulumi.get(self, "sync_interval")

    @sync_interval.setter
    def sync_interval(self, value: pulumi.Input[int]):
        pulumi.set(self, "sync_interval", value)

    @property
    @pulumi.getter(name="syncLevel")
    def sync_level(self) -> pulumi.Input[str]:
        """
        Clean library level.
        """
        return pulumi.get(self, "sync_level")

    @sync_level.setter
    def sync_level(self, value: pulumi.Input[str]):
        pulumi.set(self, "sync_level", value)


@pulumi.input_type
class _ConfigState:
    def __init__(__self__, *,
                 sync_interval: Optional[pulumi.Input[int]] = None,
                 sync_level: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering Config resources.
        :param pulumi.Input[int] sync_interval: List Update Interval.
        :param pulumi.Input[str] sync_level: Clean library level.
        """
        if sync_interval is not None:
            pulumi.set(__self__, "sync_interval", sync_interval)
        if sync_level is not None:
            pulumi.set(__self__, "sync_level", sync_level)

    @property
    @pulumi.getter(name="syncInterval")
    def sync_interval(self) -> Optional[pulumi.Input[int]]:
        """
        List Update Interval.
        """
        return pulumi.get(self, "sync_interval")

    @sync_interval.setter
    def sync_interval(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "sync_interval", value)

    @property
    @pulumi.getter(name="syncLevel")
    def sync_level(self) -> Optional[pulumi.Input[str]]:
        """
        Clean library level.
        """
        return pulumi.get(self, "sync_level")

    @sync_level.setter
    def sync_level(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "sync_level", value)


class Config(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 sync_interval: Optional[pulumi.Input[int]] = None,
                 sync_level: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        <!-- subcategory:Import Lists -->Import List Config resource.
        For more information refer to [Import List](https://wiki.servarr.com/whisparr/settings#completed-download-handling) documentation.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_whisparr as whisparr

        example = whisparr.import_lists.Config("example",
            sync_interval=24,
            sync_level="logOnly")
        ```

        ## Import

        import does not need parameters

        ```sh
         $ pulumi import whisparr:ImportLists/config:Config example
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] sync_interval: List Update Interval.
        :param pulumi.Input[str] sync_level: Clean library level.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ConfigArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        <!-- subcategory:Import Lists -->Import List Config resource.
        For more information refer to [Import List](https://wiki.servarr.com/whisparr/settings#completed-download-handling) documentation.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_whisparr as whisparr

        example = whisparr.import_lists.Config("example",
            sync_interval=24,
            sync_level="logOnly")
        ```

        ## Import

        import does not need parameters

        ```sh
         $ pulumi import whisparr:ImportLists/config:Config example
        ```

        :param str resource_name: The name of the resource.
        :param ConfigArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ConfigArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 sync_interval: Optional[pulumi.Input[int]] = None,
                 sync_level: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ConfigArgs.__new__(ConfigArgs)

            if sync_interval is None and not opts.urn:
                raise TypeError("Missing required property 'sync_interval'")
            __props__.__dict__["sync_interval"] = sync_interval
            if sync_level is None and not opts.urn:
                raise TypeError("Missing required property 'sync_level'")
            __props__.__dict__["sync_level"] = sync_level
        super(Config, __self__).__init__(
            'whisparr:ImportLists/config:Config',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            sync_interval: Optional[pulumi.Input[int]] = None,
            sync_level: Optional[pulumi.Input[str]] = None) -> 'Config':
        """
        Get an existing Config resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] sync_interval: List Update Interval.
        :param pulumi.Input[str] sync_level: Clean library level.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ConfigState.__new__(_ConfigState)

        __props__.__dict__["sync_interval"] = sync_interval
        __props__.__dict__["sync_level"] = sync_level
        return Config(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="syncInterval")
    def sync_interval(self) -> pulumi.Output[int]:
        """
        List Update Interval.
        """
        return pulumi.get(self, "sync_interval")

    @property
    @pulumi.getter(name="syncLevel")
    def sync_level(self) -> pulumi.Output[str]:
        """
        Clean library level.
        """
        return pulumi.get(self, "sync_level")

