# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['RootFolderArgs', 'RootFolder']

@pulumi.input_type
class RootFolderArgs:
    def __init__(__self__, *,
                 path: pulumi.Input[str]):
        """
        The set of arguments for constructing a RootFolder resource.
        :param pulumi.Input[str] path: Path of unmapped folder.
        """
        pulumi.set(__self__, "path", path)

    @property
    @pulumi.getter
    def path(self) -> pulumi.Input[str]:
        """
        Path of unmapped folder.
        """
        return pulumi.get(self, "path")

    @path.setter
    def path(self, value: pulumi.Input[str]):
        pulumi.set(self, "path", value)


@pulumi.input_type
class _RootFolderState:
    def __init__(__self__, *,
                 accessible: Optional[pulumi.Input[bool]] = None,
                 path: Optional[pulumi.Input[str]] = None,
                 unmapped_folders: Optional[pulumi.Input[Sequence[pulumi.Input['RootFolderUnmappedFolderArgs']]]] = None):
        """
        Input properties used for looking up and filtering RootFolder resources.
        :param pulumi.Input[bool] accessible: Access flag.
        :param pulumi.Input[str] path: Path of unmapped folder.
        :param pulumi.Input[Sequence[pulumi.Input['RootFolderUnmappedFolderArgs']]] unmapped_folders: List of folders with no associated series.
        """
        if accessible is not None:
            pulumi.set(__self__, "accessible", accessible)
        if path is not None:
            pulumi.set(__self__, "path", path)
        if unmapped_folders is not None:
            pulumi.set(__self__, "unmapped_folders", unmapped_folders)

    @property
    @pulumi.getter
    def accessible(self) -> Optional[pulumi.Input[bool]]:
        """
        Access flag.
        """
        return pulumi.get(self, "accessible")

    @accessible.setter
    def accessible(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "accessible", value)

    @property
    @pulumi.getter
    def path(self) -> Optional[pulumi.Input[str]]:
        """
        Path of unmapped folder.
        """
        return pulumi.get(self, "path")

    @path.setter
    def path(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "path", value)

    @property
    @pulumi.getter(name="unmappedFolders")
    def unmapped_folders(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['RootFolderUnmappedFolderArgs']]]]:
        """
        List of folders with no associated series.
        """
        return pulumi.get(self, "unmapped_folders")

    @unmapped_folders.setter
    def unmapped_folders(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['RootFolderUnmappedFolderArgs']]]]):
        pulumi.set(self, "unmapped_folders", value)


class RootFolder(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 path: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        <!-- subcategory:Media Management -->Root Folder resource.
        For more information refer to [Root Folders](https://wiki.servarr.com/whisparr/settings#root-folders) documentation.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_whisparr as whisparr

        example = whisparr.media_management.RootFolder("example", path="/tmp")
        ```

        ## Import

        import using the API/UI ID

        ```sh
         $ pulumi import whisparr:MediaManagement/rootFolder:RootFolder example 10
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] path: Path of unmapped folder.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: RootFolderArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        <!-- subcategory:Media Management -->Root Folder resource.
        For more information refer to [Root Folders](https://wiki.servarr.com/whisparr/settings#root-folders) documentation.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_whisparr as whisparr

        example = whisparr.media_management.RootFolder("example", path="/tmp")
        ```

        ## Import

        import using the API/UI ID

        ```sh
         $ pulumi import whisparr:MediaManagement/rootFolder:RootFolder example 10
        ```

        :param str resource_name: The name of the resource.
        :param RootFolderArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(RootFolderArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 path: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = RootFolderArgs.__new__(RootFolderArgs)

            if path is None and not opts.urn:
                raise TypeError("Missing required property 'path'")
            __props__.__dict__["path"] = path
            __props__.__dict__["accessible"] = None
            __props__.__dict__["unmapped_folders"] = None
        super(RootFolder, __self__).__init__(
            'whisparr:MediaManagement/rootFolder:RootFolder',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            accessible: Optional[pulumi.Input[bool]] = None,
            path: Optional[pulumi.Input[str]] = None,
            unmapped_folders: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['RootFolderUnmappedFolderArgs']]]]] = None) -> 'RootFolder':
        """
        Get an existing RootFolder resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] accessible: Access flag.
        :param pulumi.Input[str] path: Path of unmapped folder.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['RootFolderUnmappedFolderArgs']]]] unmapped_folders: List of folders with no associated series.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _RootFolderState.__new__(_RootFolderState)

        __props__.__dict__["accessible"] = accessible
        __props__.__dict__["path"] = path
        __props__.__dict__["unmapped_folders"] = unmapped_folders
        return RootFolder(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def accessible(self) -> pulumi.Output[bool]:
        """
        Access flag.
        """
        return pulumi.get(self, "accessible")

    @property
    @pulumi.getter
    def path(self) -> pulumi.Output[str]:
        """
        Path of unmapped folder.
        """
        return pulumi.get(self, "path")

    @property
    @pulumi.getter(name="unmappedFolders")
    def unmapped_folders(self) -> pulumi.Output[Sequence['outputs.RootFolderUnmappedFolder']]:
        """
        List of folders with no associated series.
        """
        return pulumi.get(self, "unmapped_folders")

