# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['KodiArgs', 'Kodi']

@pulumi.input_type
class KodiArgs:
    def __init__(__self__, *,
                 movie_images: pulumi.Input[bool],
                 movie_metadata: pulumi.Input[bool],
                 movie_metadata_language: pulumi.Input[int],
                 movie_metadata_url: pulumi.Input[bool],
                 use_movie_nfo: pulumi.Input[bool],
                 enable: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None):
        """
        The set of arguments for constructing a Kodi resource.
        :param pulumi.Input[bool] movie_images: Movie images flag.
        :param pulumi.Input[bool] movie_metadata: Movie metafata flag.
        :param pulumi.Input[int] movie_metadata_language: Movie metadata language.
        :param pulumi.Input[bool] movie_metadata_url: Movie metadata URL flag.
        :param pulumi.Input[bool] use_movie_nfo: Use movie nfo flag.
        :param pulumi.Input[bool] enable: Enable flag.
        :param pulumi.Input[str] name: Metadata name.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] tags: List of associated tags.
        """
        pulumi.set(__self__, "movie_images", movie_images)
        pulumi.set(__self__, "movie_metadata", movie_metadata)
        pulumi.set(__self__, "movie_metadata_language", movie_metadata_language)
        pulumi.set(__self__, "movie_metadata_url", movie_metadata_url)
        pulumi.set(__self__, "use_movie_nfo", use_movie_nfo)
        if enable is not None:
            pulumi.set(__self__, "enable", enable)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter(name="movieImages")
    def movie_images(self) -> pulumi.Input[bool]:
        """
        Movie images flag.
        """
        return pulumi.get(self, "movie_images")

    @movie_images.setter
    def movie_images(self, value: pulumi.Input[bool]):
        pulumi.set(self, "movie_images", value)

    @property
    @pulumi.getter(name="movieMetadata")
    def movie_metadata(self) -> pulumi.Input[bool]:
        """
        Movie metafata flag.
        """
        return pulumi.get(self, "movie_metadata")

    @movie_metadata.setter
    def movie_metadata(self, value: pulumi.Input[bool]):
        pulumi.set(self, "movie_metadata", value)

    @property
    @pulumi.getter(name="movieMetadataLanguage")
    def movie_metadata_language(self) -> pulumi.Input[int]:
        """
        Movie metadata language.
        """
        return pulumi.get(self, "movie_metadata_language")

    @movie_metadata_language.setter
    def movie_metadata_language(self, value: pulumi.Input[int]):
        pulumi.set(self, "movie_metadata_language", value)

    @property
    @pulumi.getter(name="movieMetadataUrl")
    def movie_metadata_url(self) -> pulumi.Input[bool]:
        """
        Movie metadata URL flag.
        """
        return pulumi.get(self, "movie_metadata_url")

    @movie_metadata_url.setter
    def movie_metadata_url(self, value: pulumi.Input[bool]):
        pulumi.set(self, "movie_metadata_url", value)

    @property
    @pulumi.getter(name="useMovieNfo")
    def use_movie_nfo(self) -> pulumi.Input[bool]:
        """
        Use movie nfo flag.
        """
        return pulumi.get(self, "use_movie_nfo")

    @use_movie_nfo.setter
    def use_movie_nfo(self, value: pulumi.Input[bool]):
        pulumi.set(self, "use_movie_nfo", value)

    @property
    @pulumi.getter
    def enable(self) -> Optional[pulumi.Input[bool]]:
        """
        Enable flag.
        """
        return pulumi.get(self, "enable")

    @enable.setter
    def enable(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enable", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Metadata name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]:
        """
        List of associated tags.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]):
        pulumi.set(self, "tags", value)


@pulumi.input_type
class _KodiState:
    def __init__(__self__, *,
                 enable: Optional[pulumi.Input[bool]] = None,
                 movie_images: Optional[pulumi.Input[bool]] = None,
                 movie_metadata: Optional[pulumi.Input[bool]] = None,
                 movie_metadata_language: Optional[pulumi.Input[int]] = None,
                 movie_metadata_url: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
                 use_movie_nfo: Optional[pulumi.Input[bool]] = None):
        """
        Input properties used for looking up and filtering Kodi resources.
        :param pulumi.Input[bool] enable: Enable flag.
        :param pulumi.Input[bool] movie_images: Movie images flag.
        :param pulumi.Input[bool] movie_metadata: Movie metafata flag.
        :param pulumi.Input[int] movie_metadata_language: Movie metadata language.
        :param pulumi.Input[bool] movie_metadata_url: Movie metadata URL flag.
        :param pulumi.Input[str] name: Metadata name.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] tags: List of associated tags.
        :param pulumi.Input[bool] use_movie_nfo: Use movie nfo flag.
        """
        if enable is not None:
            pulumi.set(__self__, "enable", enable)
        if movie_images is not None:
            pulumi.set(__self__, "movie_images", movie_images)
        if movie_metadata is not None:
            pulumi.set(__self__, "movie_metadata", movie_metadata)
        if movie_metadata_language is not None:
            pulumi.set(__self__, "movie_metadata_language", movie_metadata_language)
        if movie_metadata_url is not None:
            pulumi.set(__self__, "movie_metadata_url", movie_metadata_url)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if use_movie_nfo is not None:
            pulumi.set(__self__, "use_movie_nfo", use_movie_nfo)

    @property
    @pulumi.getter
    def enable(self) -> Optional[pulumi.Input[bool]]:
        """
        Enable flag.
        """
        return pulumi.get(self, "enable")

    @enable.setter
    def enable(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enable", value)

    @property
    @pulumi.getter(name="movieImages")
    def movie_images(self) -> Optional[pulumi.Input[bool]]:
        """
        Movie images flag.
        """
        return pulumi.get(self, "movie_images")

    @movie_images.setter
    def movie_images(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "movie_images", value)

    @property
    @pulumi.getter(name="movieMetadata")
    def movie_metadata(self) -> Optional[pulumi.Input[bool]]:
        """
        Movie metafata flag.
        """
        return pulumi.get(self, "movie_metadata")

    @movie_metadata.setter
    def movie_metadata(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "movie_metadata", value)

    @property
    @pulumi.getter(name="movieMetadataLanguage")
    def movie_metadata_language(self) -> Optional[pulumi.Input[int]]:
        """
        Movie metadata language.
        """
        return pulumi.get(self, "movie_metadata_language")

    @movie_metadata_language.setter
    def movie_metadata_language(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "movie_metadata_language", value)

    @property
    @pulumi.getter(name="movieMetadataUrl")
    def movie_metadata_url(self) -> Optional[pulumi.Input[bool]]:
        """
        Movie metadata URL flag.
        """
        return pulumi.get(self, "movie_metadata_url")

    @movie_metadata_url.setter
    def movie_metadata_url(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "movie_metadata_url", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Metadata name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]:
        """
        List of associated tags.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter(name="useMovieNfo")
    def use_movie_nfo(self) -> Optional[pulumi.Input[bool]]:
        """
        Use movie nfo flag.
        """
        return pulumi.get(self, "use_movie_nfo")

    @use_movie_nfo.setter
    def use_movie_nfo(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "use_movie_nfo", value)


class Kodi(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 enable: Optional[pulumi.Input[bool]] = None,
                 movie_images: Optional[pulumi.Input[bool]] = None,
                 movie_metadata: Optional[pulumi.Input[bool]] = None,
                 movie_metadata_language: Optional[pulumi.Input[int]] = None,
                 movie_metadata_url: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
                 use_movie_nfo: Optional[pulumi.Input[bool]] = None,
                 __props__=None):
        """
        <!-- subcategory:Metadata -->Metadata Kodi resource.
        For more information refer to [Metadata](https://wiki.servarr.com/whisparr/settings#metadata) and [KODI](https://wiki.servarr.com/whisparr/supported#xbmcmetadata).

        ## Example Usage

        ```python
        import pulumi
        import pulumi_whisparr as whisparr

        example = whisparr.metadata.Kodi("example",
            enable=True,
            movie_images=True,
            movie_metadata=True)
        ```

        ## Import

        import using the API/UI ID

        ```sh
         $ pulumi import whisparr:Metadata/kodi:Kodi example 1
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] enable: Enable flag.
        :param pulumi.Input[bool] movie_images: Movie images flag.
        :param pulumi.Input[bool] movie_metadata: Movie metafata flag.
        :param pulumi.Input[int] movie_metadata_language: Movie metadata language.
        :param pulumi.Input[bool] movie_metadata_url: Movie metadata URL flag.
        :param pulumi.Input[str] name: Metadata name.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] tags: List of associated tags.
        :param pulumi.Input[bool] use_movie_nfo: Use movie nfo flag.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: KodiArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        <!-- subcategory:Metadata -->Metadata Kodi resource.
        For more information refer to [Metadata](https://wiki.servarr.com/whisparr/settings#metadata) and [KODI](https://wiki.servarr.com/whisparr/supported#xbmcmetadata).

        ## Example Usage

        ```python
        import pulumi
        import pulumi_whisparr as whisparr

        example = whisparr.metadata.Kodi("example",
            enable=True,
            movie_images=True,
            movie_metadata=True)
        ```

        ## Import

        import using the API/UI ID

        ```sh
         $ pulumi import whisparr:Metadata/kodi:Kodi example 1
        ```

        :param str resource_name: The name of the resource.
        :param KodiArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(KodiArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 enable: Optional[pulumi.Input[bool]] = None,
                 movie_images: Optional[pulumi.Input[bool]] = None,
                 movie_metadata: Optional[pulumi.Input[bool]] = None,
                 movie_metadata_language: Optional[pulumi.Input[int]] = None,
                 movie_metadata_url: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
                 use_movie_nfo: Optional[pulumi.Input[bool]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = KodiArgs.__new__(KodiArgs)

            __props__.__dict__["enable"] = enable
            if movie_images is None and not opts.urn:
                raise TypeError("Missing required property 'movie_images'")
            __props__.__dict__["movie_images"] = movie_images
            if movie_metadata is None and not opts.urn:
                raise TypeError("Missing required property 'movie_metadata'")
            __props__.__dict__["movie_metadata"] = movie_metadata
            if movie_metadata_language is None and not opts.urn:
                raise TypeError("Missing required property 'movie_metadata_language'")
            __props__.__dict__["movie_metadata_language"] = movie_metadata_language
            if movie_metadata_url is None and not opts.urn:
                raise TypeError("Missing required property 'movie_metadata_url'")
            __props__.__dict__["movie_metadata_url"] = movie_metadata_url
            __props__.__dict__["name"] = name
            __props__.__dict__["tags"] = tags
            if use_movie_nfo is None and not opts.urn:
                raise TypeError("Missing required property 'use_movie_nfo'")
            __props__.__dict__["use_movie_nfo"] = use_movie_nfo
        super(Kodi, __self__).__init__(
            'whisparr:Metadata/kodi:Kodi',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            enable: Optional[pulumi.Input[bool]] = None,
            movie_images: Optional[pulumi.Input[bool]] = None,
            movie_metadata: Optional[pulumi.Input[bool]] = None,
            movie_metadata_language: Optional[pulumi.Input[int]] = None,
            movie_metadata_url: Optional[pulumi.Input[bool]] = None,
            name: Optional[pulumi.Input[str]] = None,
            tags: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
            use_movie_nfo: Optional[pulumi.Input[bool]] = None) -> 'Kodi':
        """
        Get an existing Kodi resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] enable: Enable flag.
        :param pulumi.Input[bool] movie_images: Movie images flag.
        :param pulumi.Input[bool] movie_metadata: Movie metafata flag.
        :param pulumi.Input[int] movie_metadata_language: Movie metadata language.
        :param pulumi.Input[bool] movie_metadata_url: Movie metadata URL flag.
        :param pulumi.Input[str] name: Metadata name.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] tags: List of associated tags.
        :param pulumi.Input[bool] use_movie_nfo: Use movie nfo flag.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _KodiState.__new__(_KodiState)

        __props__.__dict__["enable"] = enable
        __props__.__dict__["movie_images"] = movie_images
        __props__.__dict__["movie_metadata"] = movie_metadata
        __props__.__dict__["movie_metadata_language"] = movie_metadata_language
        __props__.__dict__["movie_metadata_url"] = movie_metadata_url
        __props__.__dict__["name"] = name
        __props__.__dict__["tags"] = tags
        __props__.__dict__["use_movie_nfo"] = use_movie_nfo
        return Kodi(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def enable(self) -> pulumi.Output[bool]:
        """
        Enable flag.
        """
        return pulumi.get(self, "enable")

    @property
    @pulumi.getter(name="movieImages")
    def movie_images(self) -> pulumi.Output[bool]:
        """
        Movie images flag.
        """
        return pulumi.get(self, "movie_images")

    @property
    @pulumi.getter(name="movieMetadata")
    def movie_metadata(self) -> pulumi.Output[bool]:
        """
        Movie metafata flag.
        """
        return pulumi.get(self, "movie_metadata")

    @property
    @pulumi.getter(name="movieMetadataLanguage")
    def movie_metadata_language(self) -> pulumi.Output[int]:
        """
        Movie metadata language.
        """
        return pulumi.get(self, "movie_metadata_language")

    @property
    @pulumi.getter(name="movieMetadataUrl")
    def movie_metadata_url(self) -> pulumi.Output[bool]:
        """
        Movie metadata URL flag.
        """
        return pulumi.get(self, "movie_metadata_url")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Metadata name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Sequence[int]]:
        """
        List of associated tags.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter(name="useMovieNfo")
    def use_movie_nfo(self) -> pulumi.Output[bool]:
        """
        Use movie nfo flag.
        """
        return pulumi.get(self, "use_movie_nfo")

