# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['MetadataArgs', 'Metadata']

@pulumi.input_type
class MetadataArgs:
    def __init__(__self__, *,
                 config_contract: pulumi.Input[str],
                 implementation: pulumi.Input[str],
                 enable: Optional[pulumi.Input[bool]] = None,
                 movie_images: Optional[pulumi.Input[bool]] = None,
                 movie_metadata: Optional[pulumi.Input[bool]] = None,
                 movie_metadata_language: Optional[pulumi.Input[int]] = None,
                 movie_metadata_url: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
                 use_movie_nfo: Optional[pulumi.Input[bool]] = None):
        """
        The set of arguments for constructing a Metadata resource.
        :param pulumi.Input[str] config_contract: Metadata configuration template.
        :param pulumi.Input[str] implementation: Metadata implementation name.
        :param pulumi.Input[bool] enable: Enable flag.
        :param pulumi.Input[bool] movie_images: Movie images flag.
        :param pulumi.Input[bool] movie_metadata: Movie metafata flag.
        :param pulumi.Input[int] movie_metadata_language: Movie metadata language.
        :param pulumi.Input[bool] movie_metadata_url: Movie metadata URL flag.
        :param pulumi.Input[str] name: Metadata name.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] tags: List of associated tags.
        :param pulumi.Input[bool] use_movie_nfo: Use movie nfo flag.
        """
        pulumi.set(__self__, "config_contract", config_contract)
        pulumi.set(__self__, "implementation", implementation)
        if enable is not None:
            pulumi.set(__self__, "enable", enable)
        if movie_images is not None:
            pulumi.set(__self__, "movie_images", movie_images)
        if movie_metadata is not None:
            pulumi.set(__self__, "movie_metadata", movie_metadata)
        if movie_metadata_language is not None:
            pulumi.set(__self__, "movie_metadata_language", movie_metadata_language)
        if movie_metadata_url is not None:
            pulumi.set(__self__, "movie_metadata_url", movie_metadata_url)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if use_movie_nfo is not None:
            pulumi.set(__self__, "use_movie_nfo", use_movie_nfo)

    @property
    @pulumi.getter(name="configContract")
    def config_contract(self) -> pulumi.Input[str]:
        """
        Metadata configuration template.
        """
        return pulumi.get(self, "config_contract")

    @config_contract.setter
    def config_contract(self, value: pulumi.Input[str]):
        pulumi.set(self, "config_contract", value)

    @property
    @pulumi.getter
    def implementation(self) -> pulumi.Input[str]:
        """
        Metadata implementation name.
        """
        return pulumi.get(self, "implementation")

    @implementation.setter
    def implementation(self, value: pulumi.Input[str]):
        pulumi.set(self, "implementation", value)

    @property
    @pulumi.getter
    def enable(self) -> Optional[pulumi.Input[bool]]:
        """
        Enable flag.
        """
        return pulumi.get(self, "enable")

    @enable.setter
    def enable(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enable", value)

    @property
    @pulumi.getter(name="movieImages")
    def movie_images(self) -> Optional[pulumi.Input[bool]]:
        """
        Movie images flag.
        """
        return pulumi.get(self, "movie_images")

    @movie_images.setter
    def movie_images(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "movie_images", value)

    @property
    @pulumi.getter(name="movieMetadata")
    def movie_metadata(self) -> Optional[pulumi.Input[bool]]:
        """
        Movie metafata flag.
        """
        return pulumi.get(self, "movie_metadata")

    @movie_metadata.setter
    def movie_metadata(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "movie_metadata", value)

    @property
    @pulumi.getter(name="movieMetadataLanguage")
    def movie_metadata_language(self) -> Optional[pulumi.Input[int]]:
        """
        Movie metadata language.
        """
        return pulumi.get(self, "movie_metadata_language")

    @movie_metadata_language.setter
    def movie_metadata_language(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "movie_metadata_language", value)

    @property
    @pulumi.getter(name="movieMetadataUrl")
    def movie_metadata_url(self) -> Optional[pulumi.Input[bool]]:
        """
        Movie metadata URL flag.
        """
        return pulumi.get(self, "movie_metadata_url")

    @movie_metadata_url.setter
    def movie_metadata_url(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "movie_metadata_url", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Metadata name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]:
        """
        List of associated tags.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter(name="useMovieNfo")
    def use_movie_nfo(self) -> Optional[pulumi.Input[bool]]:
        """
        Use movie nfo flag.
        """
        return pulumi.get(self, "use_movie_nfo")

    @use_movie_nfo.setter
    def use_movie_nfo(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "use_movie_nfo", value)


@pulumi.input_type
class _MetadataState:
    def __init__(__self__, *,
                 config_contract: Optional[pulumi.Input[str]] = None,
                 enable: Optional[pulumi.Input[bool]] = None,
                 implementation: Optional[pulumi.Input[str]] = None,
                 movie_images: Optional[pulumi.Input[bool]] = None,
                 movie_metadata: Optional[pulumi.Input[bool]] = None,
                 movie_metadata_language: Optional[pulumi.Input[int]] = None,
                 movie_metadata_url: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
                 use_movie_nfo: Optional[pulumi.Input[bool]] = None):
        """
        Input properties used for looking up and filtering Metadata resources.
        :param pulumi.Input[str] config_contract: Metadata configuration template.
        :param pulumi.Input[bool] enable: Enable flag.
        :param pulumi.Input[str] implementation: Metadata implementation name.
        :param pulumi.Input[bool] movie_images: Movie images flag.
        :param pulumi.Input[bool] movie_metadata: Movie metafata flag.
        :param pulumi.Input[int] movie_metadata_language: Movie metadata language.
        :param pulumi.Input[bool] movie_metadata_url: Movie metadata URL flag.
        :param pulumi.Input[str] name: Metadata name.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] tags: List of associated tags.
        :param pulumi.Input[bool] use_movie_nfo: Use movie nfo flag.
        """
        if config_contract is not None:
            pulumi.set(__self__, "config_contract", config_contract)
        if enable is not None:
            pulumi.set(__self__, "enable", enable)
        if implementation is not None:
            pulumi.set(__self__, "implementation", implementation)
        if movie_images is not None:
            pulumi.set(__self__, "movie_images", movie_images)
        if movie_metadata is not None:
            pulumi.set(__self__, "movie_metadata", movie_metadata)
        if movie_metadata_language is not None:
            pulumi.set(__self__, "movie_metadata_language", movie_metadata_language)
        if movie_metadata_url is not None:
            pulumi.set(__self__, "movie_metadata_url", movie_metadata_url)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if use_movie_nfo is not None:
            pulumi.set(__self__, "use_movie_nfo", use_movie_nfo)

    @property
    @pulumi.getter(name="configContract")
    def config_contract(self) -> Optional[pulumi.Input[str]]:
        """
        Metadata configuration template.
        """
        return pulumi.get(self, "config_contract")

    @config_contract.setter
    def config_contract(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "config_contract", value)

    @property
    @pulumi.getter
    def enable(self) -> Optional[pulumi.Input[bool]]:
        """
        Enable flag.
        """
        return pulumi.get(self, "enable")

    @enable.setter
    def enable(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enable", value)

    @property
    @pulumi.getter
    def implementation(self) -> Optional[pulumi.Input[str]]:
        """
        Metadata implementation name.
        """
        return pulumi.get(self, "implementation")

    @implementation.setter
    def implementation(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "implementation", value)

    @property
    @pulumi.getter(name="movieImages")
    def movie_images(self) -> Optional[pulumi.Input[bool]]:
        """
        Movie images flag.
        """
        return pulumi.get(self, "movie_images")

    @movie_images.setter
    def movie_images(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "movie_images", value)

    @property
    @pulumi.getter(name="movieMetadata")
    def movie_metadata(self) -> Optional[pulumi.Input[bool]]:
        """
        Movie metafata flag.
        """
        return pulumi.get(self, "movie_metadata")

    @movie_metadata.setter
    def movie_metadata(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "movie_metadata", value)

    @property
    @pulumi.getter(name="movieMetadataLanguage")
    def movie_metadata_language(self) -> Optional[pulumi.Input[int]]:
        """
        Movie metadata language.
        """
        return pulumi.get(self, "movie_metadata_language")

    @movie_metadata_language.setter
    def movie_metadata_language(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "movie_metadata_language", value)

    @property
    @pulumi.getter(name="movieMetadataUrl")
    def movie_metadata_url(self) -> Optional[pulumi.Input[bool]]:
        """
        Movie metadata URL flag.
        """
        return pulumi.get(self, "movie_metadata_url")

    @movie_metadata_url.setter
    def movie_metadata_url(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "movie_metadata_url", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Metadata name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]:
        """
        List of associated tags.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter(name="useMovieNfo")
    def use_movie_nfo(self) -> Optional[pulumi.Input[bool]]:
        """
        Use movie nfo flag.
        """
        return pulumi.get(self, "use_movie_nfo")

    @use_movie_nfo.setter
    def use_movie_nfo(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "use_movie_nfo", value)


class Metadata(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 config_contract: Optional[pulumi.Input[str]] = None,
                 enable: Optional[pulumi.Input[bool]] = None,
                 implementation: Optional[pulumi.Input[str]] = None,
                 movie_images: Optional[pulumi.Input[bool]] = None,
                 movie_metadata: Optional[pulumi.Input[bool]] = None,
                 movie_metadata_language: Optional[pulumi.Input[int]] = None,
                 movie_metadata_url: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
                 use_movie_nfo: Optional[pulumi.Input[bool]] = None,
                 __props__=None):
        """
        <!-- subcategory:Metadata -->Generic Metadata resource. When possible use a specific resource instead.
        For more information refer to [Metadata](https://wiki.servarr.com/whisparr/settings#metadata) documentation.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_whisparr as whisparr

        example = whisparr.metadata.Metadata("example",
            config_contract="MediaBrowserMetadataSettings",
            enable=True,
            implementation="MediaBrowserMetadata",
            movie_metadata=True,
            tags=[
                1,
                2,
            ])
        ```

        ## Import

        import using the API/UI ID

        ```sh
         $ pulumi import whisparr:Metadata/metadata:Metadata example 1
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] config_contract: Metadata configuration template.
        :param pulumi.Input[bool] enable: Enable flag.
        :param pulumi.Input[str] implementation: Metadata implementation name.
        :param pulumi.Input[bool] movie_images: Movie images flag.
        :param pulumi.Input[bool] movie_metadata: Movie metafata flag.
        :param pulumi.Input[int] movie_metadata_language: Movie metadata language.
        :param pulumi.Input[bool] movie_metadata_url: Movie metadata URL flag.
        :param pulumi.Input[str] name: Metadata name.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] tags: List of associated tags.
        :param pulumi.Input[bool] use_movie_nfo: Use movie nfo flag.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: MetadataArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        <!-- subcategory:Metadata -->Generic Metadata resource. When possible use a specific resource instead.
        For more information refer to [Metadata](https://wiki.servarr.com/whisparr/settings#metadata) documentation.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_whisparr as whisparr

        example = whisparr.metadata.Metadata("example",
            config_contract="MediaBrowserMetadataSettings",
            enable=True,
            implementation="MediaBrowserMetadata",
            movie_metadata=True,
            tags=[
                1,
                2,
            ])
        ```

        ## Import

        import using the API/UI ID

        ```sh
         $ pulumi import whisparr:Metadata/metadata:Metadata example 1
        ```

        :param str resource_name: The name of the resource.
        :param MetadataArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(MetadataArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 config_contract: Optional[pulumi.Input[str]] = None,
                 enable: Optional[pulumi.Input[bool]] = None,
                 implementation: Optional[pulumi.Input[str]] = None,
                 movie_images: Optional[pulumi.Input[bool]] = None,
                 movie_metadata: Optional[pulumi.Input[bool]] = None,
                 movie_metadata_language: Optional[pulumi.Input[int]] = None,
                 movie_metadata_url: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
                 use_movie_nfo: Optional[pulumi.Input[bool]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = MetadataArgs.__new__(MetadataArgs)

            if config_contract is None and not opts.urn:
                raise TypeError("Missing required property 'config_contract'")
            __props__.__dict__["config_contract"] = config_contract
            __props__.__dict__["enable"] = enable
            if implementation is None and not opts.urn:
                raise TypeError("Missing required property 'implementation'")
            __props__.__dict__["implementation"] = implementation
            __props__.__dict__["movie_images"] = movie_images
            __props__.__dict__["movie_metadata"] = movie_metadata
            __props__.__dict__["movie_metadata_language"] = movie_metadata_language
            __props__.__dict__["movie_metadata_url"] = movie_metadata_url
            __props__.__dict__["name"] = name
            __props__.__dict__["tags"] = tags
            __props__.__dict__["use_movie_nfo"] = use_movie_nfo
        super(Metadata, __self__).__init__(
            'whisparr:Metadata/metadata:Metadata',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            config_contract: Optional[pulumi.Input[str]] = None,
            enable: Optional[pulumi.Input[bool]] = None,
            implementation: Optional[pulumi.Input[str]] = None,
            movie_images: Optional[pulumi.Input[bool]] = None,
            movie_metadata: Optional[pulumi.Input[bool]] = None,
            movie_metadata_language: Optional[pulumi.Input[int]] = None,
            movie_metadata_url: Optional[pulumi.Input[bool]] = None,
            name: Optional[pulumi.Input[str]] = None,
            tags: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
            use_movie_nfo: Optional[pulumi.Input[bool]] = None) -> 'Metadata':
        """
        Get an existing Metadata resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] config_contract: Metadata configuration template.
        :param pulumi.Input[bool] enable: Enable flag.
        :param pulumi.Input[str] implementation: Metadata implementation name.
        :param pulumi.Input[bool] movie_images: Movie images flag.
        :param pulumi.Input[bool] movie_metadata: Movie metafata flag.
        :param pulumi.Input[int] movie_metadata_language: Movie metadata language.
        :param pulumi.Input[bool] movie_metadata_url: Movie metadata URL flag.
        :param pulumi.Input[str] name: Metadata name.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] tags: List of associated tags.
        :param pulumi.Input[bool] use_movie_nfo: Use movie nfo flag.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _MetadataState.__new__(_MetadataState)

        __props__.__dict__["config_contract"] = config_contract
        __props__.__dict__["enable"] = enable
        __props__.__dict__["implementation"] = implementation
        __props__.__dict__["movie_images"] = movie_images
        __props__.__dict__["movie_metadata"] = movie_metadata
        __props__.__dict__["movie_metadata_language"] = movie_metadata_language
        __props__.__dict__["movie_metadata_url"] = movie_metadata_url
        __props__.__dict__["name"] = name
        __props__.__dict__["tags"] = tags
        __props__.__dict__["use_movie_nfo"] = use_movie_nfo
        return Metadata(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="configContract")
    def config_contract(self) -> pulumi.Output[str]:
        """
        Metadata configuration template.
        """
        return pulumi.get(self, "config_contract")

    @property
    @pulumi.getter
    def enable(self) -> pulumi.Output[bool]:
        """
        Enable flag.
        """
        return pulumi.get(self, "enable")

    @property
    @pulumi.getter
    def implementation(self) -> pulumi.Output[str]:
        """
        Metadata implementation name.
        """
        return pulumi.get(self, "implementation")

    @property
    @pulumi.getter(name="movieImages")
    def movie_images(self) -> pulumi.Output[bool]:
        """
        Movie images flag.
        """
        return pulumi.get(self, "movie_images")

    @property
    @pulumi.getter(name="movieMetadata")
    def movie_metadata(self) -> pulumi.Output[bool]:
        """
        Movie metafata flag.
        """
        return pulumi.get(self, "movie_metadata")

    @property
    @pulumi.getter(name="movieMetadataLanguage")
    def movie_metadata_language(self) -> pulumi.Output[int]:
        """
        Movie metadata language.
        """
        return pulumi.get(self, "movie_metadata_language")

    @property
    @pulumi.getter(name="movieMetadataUrl")
    def movie_metadata_url(self) -> pulumi.Output[bool]:
        """
        Movie metadata URL flag.
        """
        return pulumi.get(self, "movie_metadata_url")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Metadata name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Sequence[int]]:
        """
        List of associated tags.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter(name="useMovieNfo")
    def use_movie_nfo(self) -> pulumi.Output[bool]:
        """
        Use movie nfo flag.
        """
        return pulumi.get(self, "use_movie_nfo")

